/*
 * P3
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/**********************************************
 * cmesh.h
 * Copyright (C) 2001-2002 Bertrand 'blam' LAMY
 **********************************************/

P3_cmesh* P3_cmesh_new                        (P3_cmesh*);
void      P3_cmesh_dealloc                    (P3_cmesh*);
void      P3_cmesh_batch                      (P3_cmesh*, P3_instance*);
void      P3_cmesh_render                     (P3_cmesh*, P3_instance*);
void      P3_cmesh_face_raypick               (P3_cmesh*, P3_cface*, GLfloat* raydata, int option, GLfloat* result, GLfloat* normal, void**, P3_raypickable*);
int       P3_cmesh_face_raypick_b             (P3_cmesh*, P3_cface*, GLfloat* raydata, int option);
void      P3_cmesh_raypick                    (P3_cmesh*, GLfloat* rdata, int option, GLfloat* result, GLfloat* norm, void**, P3_raypickable*);
int       P3_cmesh_raypick_b                  (P3_cmesh*, GLfloat* rdata, int option, P3_raypickable*);
void      P3_cmesh_compute_dimension          (P3_cmesh*);
void      P3_cmesh_static_light               (P3_cmesh*, P3_list* lights, int shadow);
void      P3_cmesh_build_tree                 (P3_cmesh*);
void      P3_cmesh_optimize_tree              (P3_cmesh*, GLfloat collapse, int mode, GLfloat param);
void      P3_cmesh_get_data                   (P3_cmesh*, P3_chunk*);
void      P3_cmesh_set_data                   (P3_cmesh*, P3_chunk*);
P3_cmesh* P3_cmesh_from_world                 (P3_cmesh*, P3_world*);
void      P3_cmesh_to_faces                   (P3_cmesh*, P3_world*);
void      P3_cmesh_set_visibility_all         (P3_cmesh*, int visibility);
void      P3_cmesh_set_visibility_in_sphere   (P3_cmesh*, int visibility, GLfloat[4]);
void      P3_cmesh_set_visibility_in_cylinder (P3_cmesh*, int visibility, GLfloat[3]);

//P3_cmesh* P3_cmesh_from_model (P3_model*);

