/*
 * P3
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/**********************************************
 * material.h
 * Copyright (C) 2001-2002 Bertrand 'blam' LAMY
 **********************************************/


int          P3_image_get_type            (P3_image*);
int          P3_image_get_internal_format (P3_image*);

P3_material* P3_material_new           (P3_material*);
void         P3_material_init          (P3_material*);
void         P3_material_activate      (P3_material*);
void         P3_material_inactivate    (P3_material*);
void         P3_material_compute_alpha (P3_material*);
void         P3_material_dealloc       (P3_material*);

void P3_material_get_data (P3_material*, P3_chunk*);
void P3_image_set_data    (P3_image*,    P3_chunk*);
void P3_material_set_data (P3_material*, P3_chunk*);

P3_xpack* P3_xpack_get            (int, P3_material*);
P3_xpack* P3_xpack_get_secondpass (P3_xpack*);
P3_xpack* P3_xpack_get_alpha      (P3_xpack*);
