/*
 * P3
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/**********************************************
 * sprite.h
 * Copyright (C) 2001-2002 Bertrand 'blam' LAMY
 **********************************************/

P3_sprite*    P3_sprite_new                 (P3_sprite*);
void          P3_sprite_batch               (P3_sprite*, P3_instance*);
void          P3_sprite_render              (P3_sprite*, P3_instance*);
void          P3_sprite_compute_alpha       (P3_sprite*);
void          P3_sprite_get_data            (P3_sprite*, P3_chunk*);
void          P3_sprite_set_data            (P3_sprite*, P3_chunk*);

P3_cylinder*  P3_cylinder_new               (P3_cylinder*);
void          P3_cylinder_make_context      (P3_cylinder*);
void          P3_cylinder_batch             (P3_cylinder*, P3_instance*);
void          P3_cylinder_render            (P3_cylinder*, P3_instance*);
void          P3_cylinder_get_data          (P3_cylinder*, P3_chunk*);
void          P3_cylinder_set_data          (P3_cylinder*, P3_chunk*);

P3_bonus*     P3_bonus_new                  (P3_bonus*);
void          P3_bonus_batch                (P3_bonus*, P3_instance*);
void          P3_bonus_render               (P3_bonus*, P3_instance*);
void          P3_bonus_get_data             (P3_bonus*, P3_chunk*);
void          P3_bonus_set_data             (P3_bonus*, P3_chunk*);

P3_particles* P3_particles_new              (P3_particles*);
void          P3_particles_init             (P3_particles*);
void          P3_particles_free_data        (P3_particles*);
void          P3_particles_make_context     (P3_particles*, P3_instance*);
void          P3_particles_batch            (P3_particles*, P3_instance*);
void          P3_particles_render           (P3_particles*, P3_instance*);
void          P3_particles_compute_alpha    (P3_particles*);
void          P3_particles_advance_time     (P3_particles*, GLfloat proportion);
void          P3_particles_get_fading_color (P3_particles*, GLfloat life, GLfloat max_life, GLfloat* returned_color);
void          P3_particles_get_size         (P3_particles*, GLfloat life, GLfloat max_life, GLfloat* returned_size);
GLfloat*      P3_particles_generate         (P3_particles*, int index, GLfloat life);
void          P3_particles_get_data         (P3_particles*, P3_chunk*);
void          P3_particles_set_data         (P3_particles*, P3_chunk*);




