/*
 * P3
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*****************************************
 * watercube.h
 * Copyright (C) 2003 Bertrand 'blam' LAMY
 *****************************************/

void P3_watercube_underwater_intersect_face (P3_chunk*, GLfloat*, GLfloat*, GLfloat*);
P3_watercube_underwater* P3_watercube_underwater_join_segments (GLfloat*, int);
void P3_watercube_underwater_draw_segments (P3_watercube_underwater*);

P3_watercube* P3_watercube_new               (P3_watercube*);
void          P3_watercube_dealloc           (P3_watercube*);
void          P3_watercube_init              (P3_watercube*);
void          P3_watercube_batch             (P3_watercube*, P3_instance*);
void          P3_watercube_render            (P3_watercube*);
//void          P3_watercube_render_underwater (P3_watercube*);
//void          P3_watercube_advance_time      (P3_watercube* water, float proportion);
void          P3_watercube_new_wave          (P3_watercube*, GLfloat x, GLfloat z, GLfloat height, GLfloat radius, 
                                              GLfloat decay, GLfloat wavelength, GLfloat speed, GLfloat height_decay);
void          P3_watercube_set_nb_phases     (P3_watercube*, int);
int           P3_watercube_is_underwater     (P3_watercube*, GLfloat*);
GLfloat       P3_watercube_get_waterlevel    (P3_watercube*, GLfloat x, GLfloat z, GLfloat* normal);
void          P3_watercube_get_data          (P3_watercube*, P3_chunk*);
void          P3_watercube_set_data          (P3_watercube*, P3_chunk*);
